clear all;
S0=100; %Spot price
r=0.0; %risk free rate
alpha = 0.6; %alpha parameter
var=0.04;%heston var parameter
beta=0.7; %beta parameter set from backbone or aesthetics
rho = -0.2; %rho parameter
kappa=1; %heston mean reversion parameter
nu = 0.5; %variance of volatility parameter
T=0.1; %maturity price
nsimulations=1000000; %no of MC simulations (will get doubled for anithetic)
nT=5; %no. of time step points
dt=T/nT;

%form a correlated pair of random variables for the 2 factors

for i=1:10
rndmat1=randn(nsimulations,nT);
rndmat2=randn(nsimulations,nT);
rndmat2=rho*rndmat1+(1-rho*rho)^0.5*rndmat2;

rdt=dt^0.5;
S=ones(nsimulations,1)*S0;
alphavec=ones(nsimulations,1)*alpha;
varvec=ones(nsimulations,1)*var;
for i=1:nT,
	S = S + r*S*dt + alphavec.*S.^beta*rdt.*rndmat1(:,i);%SABR
	alphavec = alphavec.*exp(nu*rdt.*rndmat2(:,i)-nu*nu*0.5*dt);%SABR
    %S = S + r*S*dt + sqrt(varvec).*S.*rdt.*rndmat1(:,i);%Heston
	%varvec = (sqrt(varvec)+nu*rndmat2(:,i)*rdt).^2.*exp(-kappa*dt);%Heston
    
end

S0
%alpha
var

Mintervall=(0.8:0.01:1.2);
ivol=[];
for i=1:41
K=Mintervall(i)*S0;
if i<20
payoff=max(S-K,0);
else payoff=S0-K+max(K-S,0);
end
ivol=[ivol,impvol(exp(-r*T)*mean(payoff),S0,K,r,0,T,0,1e-9)];
end
plot(Mintervall,ivol);
hold all;
pause;
S0=S(1);
alpha=alphavec(1);
%var=varvec(1);
end
hold off;
